<?php

/**
 * Operador
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     SetForms Team <development@setforms.com>
 * @version    Release: SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class Operador extends DaoOperador {


    /**
     * Consulta Operador pelo codigo.
     *
     * @param string $cdoperador Codigo do Operador.
     *
     * @return OperadorEntity | mixed
     */
    public static function consultaOperador($cdoperador) {

	    $obj = self::getObjectByWhere('CDOPERADOR = ?', array($cdoperador));
        return $obj;
    }


    /**
     * Consulta Operador pelo nome de Acesso.
     *
     * @param string $nmacesso Nome de Acesso.
     *
     * @return OperadorEntity | mixed
     */
    public static function consultaOperadorNmacessoUpcase($nmacesso) {

	    $obj = self::getObjectByWhere('UPPER(NMACESSO) = ?', array(strtoupper($nmacesso)));
        return $obj;
    }

    public static function consultaOperadorParcnegocio($nrparcnegocio, $nrorg){

    	return self::getObjectByWhere('NRPARCNEGOCIO = ? AND NRORG = ?', array($nrparcnegocio, $nrorg));

    }


	/**
	 * Consulta Operador pelo email.
	 *
	 * @static
	 * @param $email
	 * @return OperadorEntity | mixed
	 */
	public static function consultaOperadorPorEmail($email) {

		$obj = self::getObjectByWhere('DSEMAILOPER = ?', array($email));
        return $obj;
	}


	/**
	 * Update senha operador.
	 *
	 * @param string $cdoperador Código do Operador.
	 * @param string $senha      Senha.
	 *
	 * @return boolean
	 */
	public static function alteraSenhaOperador($cdoperador, $senha) {
		$db = \Setforms2\Runtime\Connection::getInstance();
		$query = "UPDATE OPERADOR SET CDSENHAOPERWEB = ? WHERE CDOPERADOR = ?";
		$result = $db->execute($query, array($senha, $cdoperador));
		return $result;
	}


	public static function alteraFilialOrganizacaoPerfilSelecionados($filial, $organizacao, $cdoperador) {

		$db = \Setforms2\Runtime\Connection::getInstance();
		$query = "UPDATE OPERADOR
		         SET CDFILIALSELECIONADA = ?,
				 NRORGSELECIONADA = ?
			     WHERE CDOPERADOR = ?";
		$result = $db->execute($query, array($filial, $organizacao, $cdoperador));
		return $result;
	}

    public static function desativaOperadorFromNrparcnegocio($nrparcnegocio,$nrorg){
   		try{
   	    	$desativa = "update operador SET idoperativo = 'I' WHERE nrparcnegocio = ".$nrparcnegocio." and nrorg = ".$nrorg;
   	    	\Setforms2\Runtime\Connection::getInstance()->execute($desativa);
   	    	}catch(Exception $e){
   	    		tk_warning($e->getMessage());
   	    			throw $e;
   	    	}
   	}

   	public static function ativaOperadorFromNrparcnegocio($nrparcnegocio,$nrorg){
   		try{
   	    	$ativa = "update operador SET idoperativo = 'A' WHERE nrparcnegocio = ".$nrparcnegocio." and nrorg = ".$nrorg;
   	    	\Setforms2\Runtime\Connection::getInstance()->execute($ativa);
   	    	}catch(Exception $e){
   	    		tk_warning($e->getMessage());
   	    			throw $e;
   	    	}
   	}

    /**
     * Verifica se o e-mail ja foi usado para outro usuario.
     *
     * @param string $email E-mail do usuario.
     *
     * @return boolean
     *
     * @author leonardocarvalho
     * @version 05/09/2013
     */
    public static function existeEmailCadastrado($email){

        $sql = "SELECT COUNT(1)
                FROM OPERADOR
                WHERE (DSEMAILOPER = '$email')";
        try{
            $db = self::getConnection();
            return $db->fetchOne($sql);
        }
        catch(Exception $e){
            throw new exception ($e->getMessage());
        }

    }

    /**
     * @param $operador \OperadorEntity
     */
    public static function inserirOperador($operador){

        $params = array();

        $params[] = $operador->getCdoperador();
        $params[] = $operador->getCdpais();
        $params[] = $operador->getIdatuoperador();
        $params[] = $operador->getSgestado();
        $params[] = $operador->getIdligextoper();
        $params[] = $operador->getCdmunicipio();
        $params[] = $operador->getIdoperativo();
        $params[] = $operador->getNrorg();
        $params[] = $operador->getDtinclusao();
        $params[] = 'N';
        $params[] = 'N';

        $sql = "INSERT
                  INTO OPERADOR (CDOPERADOR, CDPAIS, IDATUOPERADOR, SGESTADO, IDLIGEXTOPER, CDMUNICIPIO, IDOPERATIVO, NRORG, DTINCLUSAO, IDCADPRAPROVORE, IDCADPRPROCEORE)
                  VALUES (?,?,?,?,?,?,?,?,?,?,?)";

        try {
            \Setforms2\Runtime\Connection::getInstance()->execute($sql, $params);
        } catch (\Exception $e) {
            throw($e);
        }
    }

}