/* Tabela PARAMEMPRESA:
   Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes
   na tabela PARAMEMPRESA
   Objetivo: Gerar um log que vai registrar as alteraes na tabela PARAMEMPRESA,
   utilizando a tabela Geral de Logs de Operaes

   Criao: Lucas Primo dos Santos
   Data:    Outubro 2010
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'LOG_GER_PARAMEMPRESA' AND
                 TYPE   = 'TR'                   AND
	              U.UID  = O.UID                  AND
	              U.NAME = USER)
DROP TRIGGER LOG_GER_PARAMEMPRESA
GO

CREATE TRIGGER LOG_GER_PARAMEMPRESA
ON PARAMEMPRESA
FOR INSERT, UPDATE, DELETE
AS

   DECLARE  @V_USUARIO              VARCHAR(40);
   DECLARE  @V_TIPO                 VARCHAR(1);
   DECLARE  @V_ITPESQ               VARCHAR(40);
   DECLARE  @V_CDFILLOGOPER         VARCHAR(4);
   DECLARE  @V_DESC                 VARCHAR(300);
   DECLARE  @V_DTOPER               DATETIME;

/*VARIVEIS DO CURSOR C_CURSOR*/

   DECLARE  @V_ID_COMANDO           VARCHAR(1);

   DECLARE  @V_CDEMPRESA_OLD        VARCHAR(2);
   DECLARE  @V_CDCONFORNEM_OLD      VARCHAR(20);
   DECLARE  @V_CDCONCLIEEM_OLD      VARCHAR(20);
   DECLARE  @V_CDCONTDIFEEM_OLD     VARCHAR(20);
   DECLARE  @V_CDCTBLPERDEM_OLD     VARCHAR(20);
   DECLARE  @V_IDGERNOSNUMBOL_OLD   VARCHAR(1);
   DECLARE  @V_CDSITUCRT_OLD        VARCHAR(1);
   DECLARE  @V_IDAPROVNFTRANS_OLD   VARCHAR(1);
   DECLARE  @V_IDEMAILNFTRANS_OLD   VARCHAR(1);

   DECLARE  @V_CDEMPRESA_NEW        VARCHAR(2);
   DECLARE  @V_CDCONFORNEM_NEW      VARCHAR(20);
   DECLARE  @V_CDCONCLIEEM_NEW      VARCHAR(20);
   DECLARE  @V_CDCONTDIFEEM_NEW     VARCHAR(20);
   DECLARE  @V_CDCTBLPERDEM_NEW     VARCHAR(20);
   DECLARE  @V_IDGERNOSNUMBOL_NEW   VARCHAR(1);
   DECLARE  @V_CDSITUCRT_NEW        VARCHAR(1);
   DECLARE  @V_IDAPROVNFTRANS_NEW   VARCHAR(1);
   DECLARE  @V_IDEMAILNFTRANS_NEW   VARCHAR(1);

BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';
   SET @V_CDFILLOGOPER = '';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
   SELECT 'D'
      IDCOMANDO,
      CDEMPRESA,
      CDCONFORNEM,
      CDCONCLIEEM,
      CDCONTDIFEEM,
      CDCTBLPERDEM,
      IDGERNOSNUMBOL,
      CDSITUCRT,
      IDAPROVNFTRANS,
      IDEMAILNFTRANS,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL
     FROM
      DELETED
    WHERE
      CDEMPRESA NOT IN (SELECT CDEMPRESA FROM INSERTED)
   UNION ALL

   SELECT 'U'
      IDCOMANDO,
      DELETED.CDEMPRESA,
      DELETED.CDCONFORNEM,
      DELETED.CDCONCLIEEM,
      DELETED.CDCONTDIFEEM,
      DELETED.CDCTBLPERDEM,
      DELETED.IDGERNOSNUMBOL,
      DELETED.CDSITUCRT,
      DELETED.IDAPROVNFTRANS,
      DELETED.IDEMAILNFTRANS,
      INSERTED.CDEMPRESA,
      INSERTED.CDCONFORNEM,
      INSERTED.CDCONCLIEEM,
      INSERTED.CDCONTDIFEEM,
      INSERTED.CDCTBLPERDEM,
      INSERTED.IDGERNOSNUMBOL,
      INSERTED.CDSITUCRT,
      INSERTED.IDAPROVNFTRANS,
      INSERTED.IDEMAILNFTRANS
     FROM
      INSERTED,
      DELETED
    WHERE
      INSERTED.CDEMPRESA = DELETED.CDEMPRESA
   UNION ALL

   SELECT 'I'
      IDCOMANDO,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      NULL,
      CDEMPRESA,
      CDCONFORNEM,
      CDCONCLIEEM,
      CDCONTDIFEEM,
      CDCTBLPERDEM,
      IDGERNOSNUMBOL,
      CDSITUCRT,
      IDAPROVNFTRANS,
      IDEMAILNFTRANS
     FROM
      INSERTED
    WHERE
      CDEMPRESA NOT IN (SELECT CDEMPRESA FROM DELETED);

    OPEN C_CURSOR;
    FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                  @V_CDEMPRESA_OLD,
                                  @V_CDCONFORNEM_OLD,
                                  @V_CDCONCLIEEM_OLD,
                                  @V_CDCONTDIFEEM_OLD,
                                  @V_CDCTBLPERDEM_OLD,
                                  @V_IDGERNOSNUMBOL_OLD,
                                  @V_CDSITUCRT_OLD,
                                  @V_IDAPROVNFTRANS_OLD,
                                  @V_IDEMAILNFTRANS_OLD,
                                  @V_CDEMPRESA_NEW,
                                  @V_CDCONFORNEM_NEW,
                                  @V_CDCONCLIEEM_NEW,
                                  @V_CDCONTDIFEEM_NEW,
                                  @V_CDCTBLPERDEM_NEW,
                                  @V_IDGERNOSNUMBOL_NEW,
                                  @V_CDSITUCRT_NEW,
                                  @V_IDAPROVNFTRANS_NEW,
                                  @V_IDEMAILNFTRANS_NEW;

    WHILE (@@FETCH_STATUS = 0) BEGIN
       IF @V_ID_COMANDO = 'D' BEGIN
          IF @V_CDEMPRESA_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' Empr=' + @V_CDEMPRESA_OLD;
          END;
          IF @V_CDCONFORNEM_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' Forn=' + @V_CDCONFORNEM_OLD;
          END;
          IF @V_CDCONCLIEEM_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' Cliente=' + @V_CDCONCLIEEM_OLD;
          END;
          IF @V_CDCONTDIFEEM_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' Vendas Diferida=' + @V_CDCONTDIFEEM_OLD;
          END;
          IF @V_CDCTBLPERDEM_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' Lucros e perdas=' + @V_CDCTBLPERDEM_OLD;
          END;
          IF @V_IDGERNOSNUMBOL_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' NosNum=' + @V_IDGERNOSNUMBOL_OLD;
          END;
          IF @V_CDSITUCRT_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' CRT=' + @V_CDSITUCRT_OLD;
          END;
          IF @V_IDAPROVNFTRANS_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' AprovNFTrans=' + @V_IDAPROVNFTRANS_OLD;
          END;
          IF @V_IDEMAILNFTRANS_OLD IS NOT NULL BEGIN
             SET @V_DESC = @V_DESC + ' EmailNFTrans=' + @V_IDEMAILNFTRANS_OLD;
          END;
          SET @V_TIPO = '3';
          SET @V_ITPESQ = @V_CDEMPRESA_OLD;
       END
       ELSE BEGIN
          IF @V_ID_COMANDO = 'U' BEGIN  /*UPDATING*/
             IF (@V_CDEMPRESA_NEW      <> @V_CDEMPRESA_OLD)      OR
                (@V_CDCONFORNEM_NEW    <> @V_CDCONFORNEM_OLD)    OR
                (@V_CDCONCLIEEM_NEW    <> @V_CDCONCLIEEM_OLD)    OR
                (@V_CDCONTDIFEEM_NEW   <> @V_CDCONTDIFEEM_OLD)   OR
                (@V_CDCTBLPERDEM_NEW   <> @V_CDCTBLPERDEM_OLD)   OR
                (@V_IDGERNOSNUMBOL_NEW <> @V_IDGERNOSNUMBOL_OLD) OR
                (@V_CDSITUCRT_NEW      <> @V_CDSITUCRT_OLD)      OR
                (@V_IDAPROVNFTRANS_NEW <> @V_IDAPROVNFTRANS_OLD) OR
                (@V_IDEMAILNFTRANS_NEW <> @V_IDEMAILNFTRANS_OLD) BEGIN

                SET @V_TIPO = '2';
                SET @V_ITPESQ = @V_CDEMPRESA_OLD;
             END;
          END
          ELSE BEGIN
             SET @V_TIPO = '1';
             SET @V_ITPESQ = @V_CDEMPRESA_NEW;
          END;
       END;
       IF @V_CDEMPRESA_NEW IS NOT NULL BEGIN
          SET @V_DESC = @V_DESC + ' Empr=' + @V_CDEMPRESA_NEW;
       END;
       IF @V_CDCONFORNEM_NEW IS NOT NULL BEGIN
          SET @V_DESC = @V_DESC + ' Forn=' + @V_CDCONFORNEM_NEW;
       END;
       IF @V_CDCONCLIEEM_NEW IS NOT NULL BEGIN
          SET @V_DESC = @V_DESC + ' Cliente=' + @V_CDCONCLIEEM_NEW;
       END;
       IF @V_CDCONTDIFEEM_NEW IS NOT NULL BEGIN
          SET @V_DESC = @V_DESC + ' Vendas Diferida=' + @V_CDCONTDIFEEM_NEW;
       END;
       IF @V_CDCTBLPERDEM_NEW IS NOT NULL BEGIN
          SET @V_DESC = @V_DESC + ' Lucros e perdas=' + @V_CDCTBLPERDEM_NEW;
       END;
       IF @V_IDGERNOSNUMBOL_NEW IS NOT NULL BEGIN
          SET @V_DESC = @V_DESC + ' NosNum=' + @V_IDGERNOSNUMBOL_NEW;
       END;
       IF @V_CDSITUCRT_NEW IS NOT NULL BEGIN
          SET @V_DESC = @V_DESC + ' CRT=' + @V_CDSITUCRT_NEW;
       END;
       IF @V_IDAPROVNFTRANS_NEW IS NOT NULL BEGIN
          SET @V_DESC = @V_DESC + ' AprovNFTrans=' + @V_IDAPROVNFTRANS_NEW;
       END;
       IF @V_IDEMAILNFTRANS_NEW IS NOT NULL BEGIN
          SET @V_DESC = @V_DESC + ' EmailNFTrans=' + @V_IDEMAILNFTRANS_NEW;
       END;
       IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('PARAMEMPRESA', @V_DTOPER, @V_USUARIO,
                    @V_TIPO      , @V_ITPESQ, @V_DESC);
            END;
         END;
      END;

    FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
                                  @V_CDEMPRESA_OLD,
                                  @V_CDCONFORNEM_OLD,
                                  @V_CDCONCLIEEM_OLD,
                                  @V_CDCONTDIFEEM_OLD,
                                  @V_CDCTBLPERDEM_OLD,
                                  @V_IDGERNOSNUMBOL_OLD,
                                  @V_CDSITUCRT_OLD,
                                  @V_IDAPROVNFTRANS_OLD,
                                  @V_IDEMAILNFTRANS_OLD,
                                  @V_CDEMPRESA_NEW,
                                  @V_CDCONFORNEM_NEW,
                                  @V_CDCONCLIEEM_NEW,
                                  @V_CDCONTDIFEEM_NEW,
                                  @V_CDCTBLPERDEM_NEW,
                                  @V_IDGERNOSNUMBOL_NEW,
                                  @V_CDSITUCRT_NEW,
                                  @V_IDAPROVNFTRANS_NEW,
                                  @V_IDEMAILNFTRANS_NEW;
    END;
    CLOSE      C_CURSOR;
    DEALLOCATE C_CURSOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_GER_PARAMEMPRESA','5.85.xxx';
GO
